package com.hundsun.lcpt.pub.services.impl;

package ..deTemp.1736921969949;

import com.hundsun.jres.common.share.dataset.DatasetUtil;
import com.hundsun.jres.impl.bizkernel.runtime.exception.BizBussinessException;
import com.hundsun.jres.impl.db.session.DBSessionFactory;
import com.hundsun.jres.interfaces.bizkernel.runtime.core.IContext;
import com.hundsun.jres.interfaces.db.session.IDBSession;
import com.hundsun.jres.interfaces.share.dataset.IDataset;
import com.hundsun.lcpt.common.ContextUtil;
import com.hundsun.lcpt.common.config.SysConfigUtil;
import com.hundsun.lcpt.log.LcptLog;
import com.hundsun.lcpt.pub.api.factory.AccountApiFactory;
import com.hundsun.lcpt.pub.cache.BranchCache;
import com.hundsun.lcpt.pub.cache.ChannelInfoCache;
import com.hundsun.lcpt.pub.cache.DictCache;
import com.hundsun.lcpt.pub.cache.ParamCache;
import com.hundsun.lcpt.pub.cache.UserCache;
import com.hundsun.lcpt.pub.cache.util.DictUtil;
import com.hundsun.lcpt.pub.domain.bean.BankAcc;
import com.hundsun.lcpt.pub.domain.bean.Branch;
import com.hundsun.lcpt.pub.domain.bean.Client;
import com.hundsun.lcpt.pub.domain.bean.ClientNoMap2;
import com.hundsun.lcpt.pub.domain.bean.Dict;
import com.hundsun.lcpt.pub.domain.bean.HisClientRisk;
import com.hundsun.lcpt.pub.domain.bean.RequestFieldCheck;
import com.hundsun.lcpt.pub.domain.bean.RiskRating;
import com.hundsun.lcpt.pub.domain.bean.SysArg;
import com.hundsun.lcpt.pub.domain.bean.SysUser;
import com.hundsun.lcpt.pub.services.factory.AccountServiceFactory;
import com.hundsun.lcpt.pub.services.factory.PubServiceFactory;
import com.hundsun.lcpt.pub.services.interfaces.IBankInterface;
import com.hundsun.lcpt.pub.util.AccountShardingUtil;
import com.hundsun.lcpt.pub.util.PubParamUtil;
import com.hundsun.lcpt.util.BigDecimalUtil;
import com.hundsun.lcpt.util.DataUtil;
import com.hundsun.lcpt.util.DatasetUtil;
import com.hundsun.lcpt.util.DateUtil;
import java.sql.SQLException;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BankInterfaceService implements IBankInterface {
  public static final String HUNDSUN_VERSION = "@system 综合理财平台 @version 6.0.0.43 @sp_version IFMS6.0V202203.11.000 @lastModiDate 20220815 @describe ";
  
  private static Map<String, List<String>> fieldNameMap = new HashMap<>();
  
  private static Map<String, RequestFieldCheck> fieldDescMap = null;
  
  public boolean bankInterface(IContext context) throws BizBussinessException {
    IDataset request = context.getRequestDataset();
    asyncFieldCheck(request);
    String ismutibankNeedOperno = ParamCache.getInstance().getSysParamValue("ISMUTIBANK_NEED_OPERNO", "0");
    if ("1".equals(ParamCache.getInstance().getSysParamValue("IFMS_MUTI_BANK", "0"))) {
      if (!"1".equals(ismutibankNeedOperno) && ("6"
        .equals(request.getString("Channel")) || "0".equals(request.getString("Channel")))) {
        String operNo = request.getString("OperNo");
        SysUser user = UserCache.getInstance().getUser(operNo);
        if (null == user)
          throw new BizBussinessException("6206", "柜员不存在!"); 
        if (request.findColumn("BankNoSendUp") < 1)
          request.updateString("BankNo", user.getExtField5()); 
      } else if (!"9".equals(request.getString("Channel"))) {
        if (!DataUtil.isNullStr(request.getString("BranchNo"))) {
          Branch branch = BranchCache.getInstance().getBranch(request.getString("BranchNo"));
          if (branch != null) {
            if (request.findColumn("BankNoSendUp") < 1) {
              String bankNo = branch.getBankNo();
              DatasetUtil.setValue(request, "BankNo", bankNo);
            } 
          } else {
            throw new BizBussinessException("1370", "机构不存在!");
          } 
        } 
      } 
    } else {
      if (request.findColumn("BankNo") <= 0)
        request.addColumn("BankNo"); 
      request.updateString("BankNo", "000");
    } 
    if (request.findColumn("AccType") > 0 && 
      DataUtil.isNullStr(request.getString("InClientNo")) && 
      !DataUtil.isNullStr(request.getString("AccType")))
      if (!ParamCache.getInstance().getSysParamValue("IGNORE_CLIENT_TRANSCODES", "181236").contains(request.getString("FunctionId"))) {
        String idOrBankNo = "";
        if (DataUtil.isNullStr(request.getString("Account")))
          throw new BizBussinessException("1401", "客户标识不能为空"); 
        context.setGlobal("HostClientNo", request.getString("ClientNo"));
        if ("2".equals(request.getString("AccType"))) {
          idOrBankNo = request.getString("IdType");
          if (DataUtil.isNullStr(idOrBankNo))
            throw new BizBussinessException("1101", "证件类型不能为空"); 
        } else {
          idOrBankNo = request.getString("BankNo");
          String isCheckTwoHost100001 = ParamCache.getInstance().getSysParamValue("IS_CHECK_TWO_HOST_100001", "0");
          String directFlag = request.getString("DirectFlag");
          String directFlags = "0,1";
          DatasetUtil.setValue(request, "DirectFlag", "0");
          if (DataUtil.isNullStr(directFlag)) {
            if (!DataUtil.isNullStr(request.getString("Channel"))) {
              String relDirectFlag = "0";
              boolean isexistFlag = DictCache.getInstance().isExist("K_QDHXBZ", request.getString("Channel"));
              if (isexistFlag == true) {
                relDirectFlag = DictCache.getInstance().getPrompt("K_QDHXBZ", request.getString("Channel"));
                DatasetUtil.setValue(request, "DirectFlag", relDirectFlag);
              } 
              directFlag = relDirectFlag;
            } 
          } else if (directFlags.contains(directFlag)) {
            DatasetUtil.setValue(request, "DirectFlag", directFlag);
          } else {
            directFlag = "0";
          } 
          if ("1".equals(isCheckTwoHost100001) && 
            !DataUtil.isNullStr(request.getString("ClientNo"))) {
            ClientNoMap2 clientNoMap2 = AccountServiceFactory.getClientNoMapService().getClientNoMap2(request.getString("ClientNo"), directFlag, " ");
            if ("1".equals(directFlag) && "100001".equals(request.getString("FunctionId"))) {
              clientNoMap2 = AccountServiceFactory.getClientNoMapService().getClientNoMap2(request.getString("ClientNo"), "0", " ");
              if (clientNoMap2 != null)
                throw new BizBussinessException("1905", "当前核心客户号:" + request.getString("ClientNo") + ",在传统核心已签约，不能在另一个核心签约"); 
            } else if ("0".equals(directFlag) && "100001".equals(request.getString("FunctionId"))) {
              clientNoMap2 = AccountServiceFactory.getClientNoMapService().getClientNoMap2(request.getString("ClientNo"), "1", " ");
              if (clientNoMap2 != null)
                throw new BizBussinessException("1905", "当前核心客户号:" + request.getString("ClientNo") + ",在直销核心已签约，不能在另一个核心签约"); 
            } 
            if (clientNoMap2 != null) {
              DatasetUtil.setValue(request, "Account", clientNoMap2.getInClientNo());
              DatasetUtil.setValue(request, "AccType", "1");
              DatasetUtil.setValue(request, "ClientNo", clientNoMap2.getInClientNo());
              context.setGlobal("ClientNoMap2", clientNoMap2);
            } else {
              clientNoMap2 = AccountServiceFactory.getClientNoMapService().getClientNoMap2(" ", directFlag, request.getString("ClientNo"));
              if (clientNoMap2 != null) {
                DatasetUtil.setValue(request, "Account", request.getString("ClientNo"));
                DatasetUtil.setValue(request, "AccType", "1");
                context.setGlobal("ClientNoMap2", clientNoMap2);
                context.setGlobal("HostClientNo", clientNoMap2.getClientNo());
              } else {
                if ("100002".equals(request.getString("FunctionId")))
                  throw new BizBussinessException("1905", "解约上送核心客户号只能在对应核心做解约"); 
                if (!DataUtil.isNullStr(request.getString("IdCode"))) {
                  DatasetUtil.setValue(request, "AccType", "2");
                  DatasetUtil.setValue(request, "Account", request.getString("IdCode"));
                  idOrBankNo = request.getString("IdType");
                  if (DataUtil.isNullStr(idOrBankNo))
                    throw new BizBussinessException("1101", "证件类型不能为空"); 
                } 
              } 
            } 
          } 
          if (DataUtil.isNullStr(idOrBankNo))
            throw new BizBussinessException("9997", "银行号不能为空"); 
        } 
        String changeCardTrans = "100003,110903,100631";
        if ("0".equals(request.getString("AccType")) && 
          !DataUtil.isNullStr(request.getString("Account")) && 

          
          !request.getString("BankAcc").equals(request.getString("Account")) && 
          
          !DataUtil.contains(changeCardTrans, request.getString("FunctionId"))) {
          if (!DataUtil.isNullStr(request.getString("BankAcc")))
            throw new BizBussinessException("6106", "银行账号输入有误"); 
          DatasetUtil.setValue(request, "BankAcc", request.getString("Account"));
        } 
        String inClientNo = AccountServiceFactory.getClientService().getInClientNo(request.getString("AccType"), request
            .getString("Account"), idOrBankNo);
        if ("5".equals(request.getString("AccType"))) {
          String bankAcc = AccountServiceFactory.getClientService().getBankaccByTaClient(inClientNo, request.getString("Account"), idOrBankNo);
          if (DataUtil.isNullStr(request.getString("BankAcc"))) {
            DatasetUtil.setValue(request, "AccType", "0");
            DatasetUtil.setValue(request, "Account", bankAcc);
            DatasetUtil.setValue(request, "BankAcc", bankAcc);
          } else if (!request.getString("BankAcc").equals(bankAcc)) {
            throw new BizBussinessException("1114", "根据交易账号查询的银行卡号和上送银行卡号不一致");
          } 
        } else if (!DataUtil.isNullStr(request.getString("TaClient"))) {
          if ("2".equals(request.getString("AccType")))
            idOrBankNo = request.getString("BankNo"); 
          String bankAcc = AccountServiceFactory.getClientService().getBankaccByTaClient(inClientNo, request.getString("TaClient"), idOrBankNo);
          if (DataUtil.isNullStr(request.getString("BankAcc"))) {
            DatasetUtil.setValue(request, "BankAcc", bankAcc);
          } else if (!request.getString("BankAcc").equals(bankAcc)) {
            throw new BizBussinessException("1114", "根据交易账号查询的银行卡号和上送银行卡号不一致");
          } 
        } 
        if (!DataUtil.isNullStr(request.getString("OldTaClient"))) {
          String oldBankAcc = AccountApiFactory.getBankaccByTaClient(inClientNo, request.getString("OldTaClient"), request.getString("BankNo"));
          if (DataUtil.isNullStr(request.getString("OldBankAcc"))) {
            DatasetUtil.setValue(request, "OldBankAcc", oldBankAcc);
          } else if (!request.getString("OldBankAcc").equals(oldBankAcc)) {
            throw new BizBussinessException("1114", "根据交易账号查询的银行卡号和上送银行卡号不一致");
          } 
        } 
        if (DataUtil.isNullStr(inClientNo) && request
          .getString("FunctionId").equals("100001") && 
          !request.getString("AccType").equals("2")) {
          inClientNo = AccountServiceFactory.getClientService().getInClientNo("2", request
              .getString("IdCode"), request.getString("IdType"));
          DatasetUtil.setValue(request, "IdFlag", "1");
        } 
        String noCheckTrans = "100001,100005,100006,100386,100010,100300,100681,100363,109312,100855";
        if ("1".equals(ParamCache.getInstance().getSysParamValue("NOT_CHK_SIGN_100353", "1")))
          noCheckTrans = noCheckTrans + ",100353"; 
        String noCheckTransCodes = ParamCache.getInstance().getSysParamValue("NOCHK_INCLIENTNO_CODES", "");
        if (!DataUtil.isNullStr(noCheckTransCodes))
          noCheckTrans = noCheckTrans + "," + noCheckTransCodes; 
        boolean checkInClientNo = !DataUtil.contains(noCheckTrans, request.getString("FunctionId"));
        if ("100801".equals(request.getString("FunctionId")) && "1".equals(request.getString("OnlyCheck")))
          checkInClientNo = false; 
        inClientNo = dealAutoSign(context, inClientNo);
        if (checkInClientNo && DataUtil.isNullStr(inClientNo))
          throw new BizBussinessException("1114", "客户信息不存在"); 
        if (request.findColumn("InClientNo") > 0) {
          request.updateString("InClientNo", inClientNo);
        } else {
          request.addColumn("InClientNo", 83);
          request.updateString("InClientNo", inClientNo);
        } 
        context.setGlobal("$_APP_INCLIENTNO", inClientNo);
        String FTUCheckTrans = SysConfigUtil.getSysConfig().getValue("FTU_CHECK_TRANS");
        if (ParamCache.getInstance().getSysParamValue("enableFTUModule", "0").equals("1") && 
          DataUtil.contains(FTUCheckTrans, request.getString("FunctionId"))) {
          String bankAcc = "0".equals(request.getString("AccType")) ? request.getString("Account") : request.getString("BankAcc");
          if (!DataUtil.isNullStr(bankAcc) && PubServiceFactory.getFTUService().isFTUAccount(bankAcc))
            PubServiceFactory.getFTUService().checkFTUBranchAndOper(request.getString("BranchNo"), request.getString("OperNo")); 
        } 
        String checkPwdChannels = SysConfigUtil.getSysConfig().getValue("CHECK_PWD_CHANNELS");
        String checkPwdTrans = SysConfigUtil.getSysConfig().getValue("CHECK_PWD_TRANS");
        if (!DataUtil.isNullStr(checkPwdChannels) && !DataUtil.isNullStr(checkPwdTrans) && checkPwdChannels
          .contains(request.getString("Channel")) && checkPwdTrans
          .contains(request.getString("FunctionId"))) {
          if (DataUtil.isNullStr(request.getString("Passwd")))
            throw new BizBussinessException("1111", "上送密码为空"); 
          AccountServiceFactory.getClientService().checkTransPasswd(inClientNo, request.getString("Passwd"));
        } 
        String transControl = ParamCache.getInstance().getSysParamValue("ControlIDCodeDate", "-1");
        if (DataUtil.contains(transControl, request.getString("FunctionId"))) {
          String idCodeDate = "";
          String actorIdValid = "";
          String reprDocuValid = "";
          String phyDate = "";
          String date = "";
          phyDate = request.getString("TransDate");
          int endPos = transControl.indexOf("~", transControl.indexOf(request.getString("FunctionId")));
          String transCtrInfo = transControl.substring(transControl.indexOf(request.getString("FunctionId")), (endPos > 0) ? endPos : transControl.length());
          int day = -89;
          try {
            day = transCtrInfo.contains(":") ? Integer.parseInt(transCtrInfo.substring(transCtrInfo.indexOf(":") + 1)) : day;
          } catch (Exception e) {
            LcptLog.getTransLogNoCache().warn("[" + transCtrInfo + "]证件过期时间配置错误,将默认为[" + day + "]");
          } 
          date = DateUtil.addDate(phyDate, day);
          try {
            if (request.getString("FunctionId").equals("100001")) {
              idCodeDate = request.getString("IdCodeDate");
              actorIdValid = request.getString("ActorDocuValid");
              reprDocuValid = request.getString("ReprDocuValid");
              if ("0".equals(request.getString("ClientType"))) {
                if (DataUtil.isNullStr(idCodeDate))
                  throw new BizBussinessException("1372", "机构客户证件有效日期不能为空"); 
                if (date.compareTo(idCodeDate) > 0)
                  throw new BizBussinessException("1372", "机构客户证件已过期，无法交易"); 
                if (DataUtil.isNullStr(actorIdValid))
                  throw new BizBussinessException("1372", "机构经办人证件有效期不能为空"); 
                if (date.compareTo(actorIdValid) > 0)
                  throw new BizBussinessException("1372", "机构经办人证件已过期，无法交易"); 
                if (DataUtil.isNullStr(reprDocuValid))
                  throw new BizBussinessException("1372", "法人证件有效期不能为空"); 
                if (date.compareTo(reprDocuValid) > 0)
                  throw new BizBussinessException("1372", "机构法人证件已过期，无法交易"); 
              } else {
                if (DataUtil.isNullStr(idCodeDate))
                  throw new BizBussinessException("1372", "个人客户证件有效日期不能为空"); 
                if (date.compareTo(idCodeDate) > 0)
                  throw new BizBussinessException("1372", "个人客户证件已过期，无法交易"); 
              } 
            } else {
              SysArg sysArg = (SysArg)ContextUtil.getContextAttribute(context, "$_APP_SYSARG");
              AccountServiceFactory.getClientService().checkIdCodeDate(inClientNo, request.getString("BankNo"), sysArg.getSellerCode(), date);
            } 
          } catch (BizBussinessException e) {
            String errorTip = ParamCache.getInstance().getSysParamValue("TRANS_CTOL_TIP_INFO", "");
            if (!DataUtil.isNullStr(errorTip))
              throw new BizBussinessException(e.getErrorNo(), errorTip); 
            throw new BizBussinessException(e.getErrorNo(), e.getErrorMessage());
          } 
        } 
        if ("1".equals(PubParamUtil.getPubSysParamValue("AML_BLACKLIST_CHECK", "0"))) {
          Client client = null;
          if (!DataUtil.isNullStr(inClientNo))
            client = AccountServiceFactory.getClientService().getClientBaseInfoByInclientno(inClientNo); 
          SysArg sysArg = (SysArg)ContextUtil.getContextAttribute(context, "$_APP_SYSARG");
          PubServiceFactory.getAmlClientService().checkAmlBlacklist(request, sysArg, null, client, request.getString("FunctionId"), null);
          if (!DataUtil.isNullStr(request.getString("AmlBlackFlag")))
            context.setGlobal("AmlBlackFlag", request.getString("AmlBlackFlag")); 
        } 
        if (request.getString("FunctionId").equals("100001") && 
          !DataUtil.isNullStr(PubParamUtil.getPubSysParamValue("RISK_AGE_QUESTION", " ")) && "1"
          .equals(request.getString("ClientType").trim()) && 
          !DataUtil.isNullStr((String)context.getGlobal("$_APP_INCLIENTNO")))
          riskAgeCheck(context, request); 
      }  
    if ("2".equals(request.getString("AccType")) && DataUtil.isNullStr(request.getString("IdCode")))
      DatasetUtil.setValue(request, "IdCode", request.getString("Account")); 
    if ("0".equals(ParamCache.getInstance().getSysParamValue("CHECK_TRANSFER_SWITCH", "0"))) {
      String transferFlag = request.getString("TransferFlag");
      String ifm30SuccessErrCode = PubParamUtil.getPubSysParamValue("T" + request.getString("FunctionId") + "_TO_IFM30", "");
      if (!"1".equals(transferFlag) && !DataUtil.isNullStr(ifm30SuccessErrCode)) {
        IDataset ifm30Request = DatasetUtil.copyDataset(request);
        DatasetUtil.setValue(ifm30Request, "OriFunctionId", request.getString("FunctionId"));
        DatasetUtil.setValue(ifm30Request, "FunctionId", "499" + request.getString("FunctionId").substring(3, 6));
        if ("1".equals(ParamCache.getInstance().getSysParamValue("SENDTHIRDSYS_BANKACCMODE", "0")))
          if ("2".equals(request.getString("AccType")) && !DataUtil.isNullStr(request.getString("Account"))) {
            DatasetUtil.setValue(ifm30Request, "IdType", request.getString("IdType"));
            DatasetUtil.setValue(ifm30Request, "IdCode", request.getString("Account"));
          } else if (!DataUtil.isNullStr((String)context.getGlobal("$_APP_INCLIENTNO"))) {
            Client client = AccountServiceFactory.getClientService().getClientBaseInfoByInclientno((String)context.getGlobal("$_APP_INCLIENTNO"));
            if (client != null) {
              DatasetUtil.setValue(ifm30Request, "AccType", "2");
              DatasetUtil.setValue(ifm30Request, "Account", client.getIdCode());
              DatasetUtil.setValue(ifm30Request, "IdType", client.getIdType());
              DatasetUtil.setValue(ifm30Request, "IdCode", client.getIdCode());
            } 
          }  
        IDataset ifm30Response = PubServiceFactory.getPubHostService().execute400011(context, ifm30Request);
        if (DataUtil.isNullStr(ifm30Response.getString("ErrorNo"))) {
          LcptLog.getTransLogNoCache().error("转发3.0交易失败");
          throw new BizBussinessException("9999", "交易失败");
        } 
        if (ifm30Response != null && !ifm30SuccessErrCode.contains(ifm30Response.getString("ErrorNo")))
          throw new BizBussinessException(ifm30Response.getString("ErrorNo"), ifm30Response.getString("ErrorInfo")); 
      } 
    } 
    if ("1".equals(PubParamUtil.getPubSysParamValue("MUST_SIGN_BANKCC", "0")) && 
      !DataUtil.isNullStr(request.getString("InClientNo")) && !PubParamUtil.getPubSysParamValue("MUST_SING_ACC_EXCTRANS", "100001,100013,100353").contains(request.getString("FunctionId"))) {
      String bankAccStr = "";
      if ("0".equals(request.getString("AccType")))
        bankAccStr = request.getString("Account"); 
      if (!DataUtil.isNullStr(request.getString("BankAcc")))
        bankAccStr = request.getString("BankAcc"); 
      if (!DataUtil.isNullStr(bankAccStr)) {
        BankAcc bankAcc = AccountServiceFactory.getBankAccService().getBankAcc(request.getString("BankNo"), bankAccStr, request
            .getString("InClientNo"));
        if (bankAcc == null || !"0".equals(bankAcc.getAccStatus()))
          throw new BizBussinessException("1108", "银行账号未签约或者未登记"); 
      } 
    } 
    List<String> introlChannelsParam = Arrays.asList(PubParamUtil.getPubSysParamValue("INTRO_CHANNELS", "").split(","));
    if ("1".equals(ParamCache.getInstance().getSysParamValue("IntroChannel", "0")))
      if ((ChannelInfoCache.getInstance().getChannelInfo(request.getString("Channel")) != null || introlChannelsParam.contains(request.getString("Channel")) || (
        !DataUtil.isNullStr(request.getString("IntroChannel")) && introlChannelsParam.contains(request.getString("IntroChannel")))) && 
        
        !PubParamUtil.getPubSysParamValue("INTROL_USE_ORIACCTRANS", "100001,100013,100003,100014,100301").contains(request.getString("FunctionId")) && (
        
        !DataUtil.isNullStr(request.getString("BankAcc")) || ("0".equals(request.getString("AccType")) && !DataUtil.isNullStr(request.getString("Account"))))) {
        String introlChannel = request.getString("IntroChannel");
        if (DataUtil.isNullStr(introlChannel))
          introlChannel = request.getString("Channel"); 
        if (DataUtil.isNullStr(request.getString("OutBankAcc")))
          DatasetUtil.setValue(request, "OutBankAcc", DataUtil.isNullStr(request.getString("BankAcc")) ? request.getString("Account") : request.getString("BankAcc")); 
        if (!DataUtil.isNullStr(request.getString("BankAcc")))
          DatasetUtil.setValue(request, "BankAcc", introlChannel + "$I$" + request.getString("BankAcc")); 
        if ("0".equals(request.getString("AccType")) && !DataUtil.isNullStr(request.getString("Account")))
          DatasetUtil.setValue(request, "Account", introlChannel + "$I$" + request.getString("Account")); 
        if (DataUtil.isNullStr(request.getString("IntroChannel")))
          DatasetUtil.setValue(request, "IntroChannel", request.getString("Channel")); 
      }  
    if ("1".equals(PubParamUtil.getPubSysParamValue("ShiftClientNameAndBankAccName", "0"))) {
      String shiftClientNameChannel = PubParamUtil.getPubSysParamValue("SHIFT_CLIENTNAME_CHANNELS", "");
      if (DataUtil.isNullStr(shiftClientNameChannel)) {
        String functionId = request.getString("FunctionId");
        if ("100001".equals(functionId) || "100013".equals(functionId)) {
          DatasetUtil.setValue(request, "OutBankAccName", request.getString("ClientName"));
          DatasetUtil.setValue(request, "OutBankName", request.getString("BankAccName"));
        } 
      } else if (shiftClientNameChannel.contains(request.getString("Channel"))) {
        String functionId = request.getString("FunctionId");
        if ("100001".equals(functionId) || "100013".equals(functionId)) {
          DatasetUtil.setValue(request, "OutBankAccName", request.getString("ClientName"));
          DatasetUtil.setValue(request, "OutBankName", request.getString("BankAccName"));
        } 
      } 
    } 
    if (PubParamUtil.getPubSysParamValue("CHECK_BLACK_LIST_TRANS", "").contains(request.getString("FunctionId"))) {
      if ("1".equals(PubParamUtil.getPubSysParamValue("CHECK_BLACK_BY_HOST", "0"))) {
        IDataset checkRequest = DatasetUtil.copyDataset(request);
        DatasetUtil.setValue(checkRequest, "FunctionId", "400099");
        IDataset checkResponse = PubServiceFactory.getPubHostService().hostSendAndReceive(context, checkRequest);
        if (checkResponse != null && !"AAAAAAA".equals(checkResponse.getString("ErrorNo")))
          throw new BizBussinessException(checkResponse.getString("ErrorNo"), checkResponse.getString("ErrorInfo")); 
      } 
      String ctrlAccountType1 = "1";
      String ctrlAccount1 = request.getString("ClientNo");
      String ctrlAccountType2 = "2";
      String ctrlIdType2 = request.getString("IdType");
      String ctrlAccount2 = request.getString("IdCode");
      String ctrlAccountType3 = "0";
      String ctrlAccount3 = request.getString("BankAcc");
      PubServiceFactory.getWhiteBlackListService().checkSystemBlackList(ctrlAccount1, ctrlAccountType1, ctrlAccount2, ctrlAccountType2, ctrlIdType2, ctrlAccount3, ctrlAccountType3);
    } 
    String signPrdTypesGroup = PubParamUtil.getPubSysParamValue("SIGN_PRDTYPES_GROUP", "");
    if (("100001".equals(request.getString("FunctionId")) || "100002"
      .equals(request.getString("FunctionId"))) && 
      !DataUtil.isNullStr(request.getString("PrdTypes")) && !DataUtil.isNullStr(signPrdTypesGroup)) {
      String prdTypes = request.getString("PrdTypes");
      prdTypes = getDistinctPrdType(prdTypes, signPrdTypesGroup);
      request.updateString("PrdTypes", prdTypes);
    } 
    List<Dict> filterLineBreaksList = DictCache.getInstance().getDictList("K_GLHHF");
    for (Dict dict : filterLineBreaksList) {
      String specialCharactersStr = ParamCache.getInstance().getSysParamValue("IS_FILTER_SPECIAL_CHARACTERS", "\\n");
      if (!DataUtil.isNullStr(specialCharactersStr)) {
        String[] specialCharactersList = specialCharactersStr.split(",");
        for (String sp : specialCharactersList)
          DatasetUtil.setValue(request, dict.getVal(), request.getString(dict.getVal()).replaceAll("[" + sp + "]", "")); 
      } 
    } 
    String asyncChgClientNo = ParamCache.getInstance().getSysParamValue("NOTICE_TYPE5", "");
    boolean isAsyncChgClientNo = (!DataUtil.isNullStr(asyncChgClientNo) && asyncChgClientNo.contains("PUB_BATCH"));
    if (isAsyncChgClientNo && !DataUtil.isNullStr(request.getString("InClientNo"))) {
      IDBSession session = DBSessionFactory.getSession();
      int num = 0;
      String clinetNo = "";
      try {
        String tbclientseller = AccountShardingUtil.getTableNameByInClientNo("tbclientseller", request.getString("InClientNo"));
        IDataset dataSet = session.getDataSet("select client_no from " + tbclientseller + " where in_client_no=?", new Object[] { request.getString("InClientNo") });
        if (dataSet.getRowCount() > 0) {
          dataSet.beforeFirst();
          dataSet.next();
          clinetNo = dataSet.getString("client_no");
        } 
        num = session.account("select count(1) from tbaccreq a where ( a.in_client_no =? or a.client_no =? ) and a.trans_code='100522' and  (a.status='1' or a.status='4'  and  exists (select 1 from tbmsgnoticesync b where b.serial_no=a.serial_no and (b.status='1' or b.status='S' or b.status='Z' or b.status='4' and b.restore_status='1')))", new Object[] { request
              
              .getString("InClientNo"), clinetNo });
      } catch (SQLException e) {
        LcptLog.getTransLogNoCache().error("客户号合并查询数据库操作失败", e);
      } catch (Exception e) {
        LcptLog.getTransLogNoCache().error("客户号合并查询异常", e);
      } 
      if (num > 0)
        throw new BizBussinessException("3414", "该客户【" + request.getString("InClientNo") + "/" + clinetNo + "】存在在途客户号合并交易，不允许交易"); 
    } 
    return false;
  }
  
  private void asyncFieldCheck(IDataset request) throws BizBussinessException {
    if ("1".equals(PubParamUtil.getPubSysParamValue("REQUEST_FIELD_CHK_REREAD", "0"))) {
      fieldNameMap = new HashMap<>();
      fieldDescMap = null;
    } 
    if (fieldDescMap == null) {
      fieldDescMap = new HashMap<>();
      IDBSession session = null;
      try {
        session = DBSessionFactory.getSession();
        List<RequestFieldCheck> list = session.getObjectList("select * from tbrequestfieldcheck", RequestFieldCheck.class);
        for (int i = 0; i < list.size(); i++) {
          RequestFieldCheck currRequestFieldCheck = list.get(i);
          fieldDescMap.put(currRequestFieldCheck.getTransCode() + "~" + currRequestFieldCheck.getFieldCode(), currRequestFieldCheck);
          if (fieldNameMap.get(currRequestFieldCheck.getTransCode()) == null) {
            List<String> tmpList = new ArrayList<>();
            tmpList.add(currRequestFieldCheck.getFieldCode());
            fieldNameMap.put(currRequestFieldCheck.getTransCode(), tmpList);
          } else {
            ((List<String>)fieldNameMap.get(currRequestFieldCheck.getTransCode())).add(currRequestFieldCheck.getFieldCode());
          } 
        } 
      } catch (SQLException e) {
        LcptLog.getTransLogNoCache().error("数据库异常", e);
        throw new BizBussinessException("1900", "数据库异常");
      } 
    } 
    if (fieldNameMap != null && fieldNameMap
      .get(request.getString("FunctionId")) != null && ((List)fieldNameMap
      .get(request.getString("FunctionId"))).size() > 0) {
      List<String> listTmp = fieldNameMap.get(request.getString("FunctionId"));
      for (int i = 0; i < listTmp.size(); i++) {
        RequestFieldCheck requestFieldCheck = fieldDescMap.get(request.getString("FunctionId") + "~" + (String)listTmp.get(i));
        if (requestFieldCheck == null) {
          LcptLog.getTransLogNoCache().error(request.getString("FunctionId") + "~" + (String)listTmp.get(i) + "为空");
        } else {
          String dataTypeString = "1";
          String dataTypeInt = "2";
          String dataTypeDouble = "3";
          if (dataTypeString.equals(requestFieldCheck.getDataType())) {
            if ("0".equals(requestFieldCheck.getNullAllow()) && 
              DataUtil.isNullStr(request.getString(requestFieldCheck.getFieldCode())))
              throw new BizBussinessException("1016", requestFieldCheck.getFieldName() + "为空"); 
            if (!DataUtil.isNullStr(request.getString(requestFieldCheck.getFieldCode())) && 
              !DataUtil.isNullStr(requestFieldCheck.getDatadict()) && 
              !DictCache.getInstance().isExist(requestFieldCheck.getDatadict(), request.getString(requestFieldCheck.getFieldCode())))
              throw new BizBussinessException("1016", requestFieldCheck.getFieldName() + "的值有误"); 
            if (!DataUtil.isNullStr(request.getString(requestFieldCheck.getFieldCode())) && requestFieldCheck
              .getMaxLength() > 0 && request
              .getString(requestFieldCheck.getFieldCode()).trim().length() > requestFieldCheck.getMaxLength())
              throw new BizBussinessException("1016", requestFieldCheck.getFieldName() + "的值过长"); 
          } else if (dataTypeInt.equals(requestFieldCheck.getDataType())) {
            if ("0".equals(requestFieldCheck.getNullAllow()) && request
              .getInt(requestFieldCheck.getFieldCode()) <= 0)
              throw new BizBussinessException("1016", requestFieldCheck.getFieldName() + "为空"); 
            if (!DataUtil.isNullStr(request.getString(requestFieldCheck.getFieldCode())) && requestFieldCheck
              .getMaxLength() > 0 && request
              .getInt(requestFieldCheck.getFieldCode()) > requestFieldCheck.getMaxLength())
              throw new BizBussinessException("1016", requestFieldCheck.getFieldName() + "的值过长"); 
          } else if (dataTypeDouble.equals(requestFieldCheck.getDataType())) {
            if ("0".equals(requestFieldCheck.getNullAllow()) && 
              BigDecimalUtil.compare(request.getDouble(requestFieldCheck.getFieldCode()), 0.0D) <= 0)
              throw new BizBussinessException("1016", requestFieldCheck.getFieldName() + "为空"); 
            if (!DataUtil.isNullStr(request.getString(requestFieldCheck.getFieldCode())) && requestFieldCheck
              .getMaxLength() > 0 && request
              .getInt(requestFieldCheck.getFieldCode()) > requestFieldCheck.getMaxLength())
              throw new BizBussinessException("1016", requestFieldCheck.getFieldName() + "的值过长"); 
          } 
        } 
      } 
    } 
  }
  
  private String dealAutoSign(IContext context, String inClientNo) throws BizBussinessException {
    if ("1".equals(PubParamUtil.getPubSysParamValue("MUTI_BANK_ONLY_SING_ONE", "0"))) {
      SysArg sysArg = (SysArg)ContextUtil.getContextAttribute(context, "$_APP_SYSARG");
      IDataset request = context.getRequestDataset();
      String requestStr = DatasetUtil.dataset2Json(request, "utf-8");
      inClientNo = AccountServiceFactory.getClientService().dealAutoSign(sysArg.getSellerCode(), inClientNo, requestStr);
    } 
    return inClientNo;
  }
  
  private String getDistinctPrdType(String prdTypes, String signPrdTypesGroup) {
    int i = 0;
    while (i < signPrdTypesGroup.length()) {
      if (!prdTypes.contains(DataUtil.getCharAt(signPrdTypesGroup, i)))
        prdTypes = prdTypes + DataUtil.getCharAt(signPrdTypesGroup, i); 
      i++;
    } 
    return prdTypes;
  }
  
  private void riskAgeCheck(IContext context, IDataset request) throws BizBussinessException {
    String riskPaperAgeQuestion = ParamCache.getInstance().getSysParamValue("RISK_AGE_QUESTION", " ");
    HisClientRisk hisClientRisk = null;
    try {
      IDBSession session = DBSessionFactory.getSession();
      hisClientRisk = (HisClientRisk)session.getObject("select * from tbhisclientrisk where in_client_no= ? and bank_acc= ? and question= ? order by risk_date desc,risk_time desc", HisClientRisk.class, new Object[] { context
            .getGlobal("$_APP_INCLIENTNO"), request.getString("BankAcc"), riskPaperAgeQuestion });
    } catch (Exception e) {
      LcptLog.getTransLogNoCache().error("风险评估答案查询异常", e);
    } 
    String riskOption = "";
    int riskDate = 0;
    if (hisClientRisk != null) {
      riskDate = hisClientRisk.getRiskDate();
      riskOption = hisClientRisk.getRiskOption();
    } 
    if ("1".equals(ParamCache.getInstance().getSysParamValue("USE_RATING_RISK", "0")) && 
      !DataUtil.isNullStr(request.getString("ClientNo"))) {
      IDBSession session = DBSessionFactory.getSession();
      StringBuilder sql = new StringBuilder();
      RiskRating riskRating = null;
      try {
        sql.append("select * from tbriskrating where cont_id=?");
        riskRating = (RiskRating)session.getObject(sql.toString(), RiskRating.class, new Object[] { request.getString("ClientNo") });
      } catch (SQLException e) {
        LcptLog.getTransLogNoCache().error("风险评估过渡答案查询异常", e);
      } 
      if (riskRating != null && Integer.parseInt(riskRating.getCreDt().replaceAll("-", "")) > riskDate)
        riskOption = String.valueOf(riskRating.getRateOption().charAt(Integer.parseInt(riskPaperAgeQuestion) - 1)); 
    } 
    if (!DataUtil.isNullStr(riskOption)) {
      String agePeriod = DictUtil.getPrompt("K_WJNLDAGX", riskOption);
      String[] age = agePeriod.split(":");
      String[] age1 = age[1].split("~");
      String birthday = request.getString("Birthday");
      if ("1".equals(ParamCache.getInstance().getSysParamValue("USE_IDCODE_DATE", "0")) && "0"
        .equals(request.getString("IdType")) && 
        !DataUtil.isNullStr(request.getString("IdCode"))) {
        String idCode = request.getString("IdCode");
        if (idCode.length() != 15) {
          birthday = idCode.substring(6, 14);
        } else {
          birthday = "19" + idCode.substring(6, 12);
        } 
      } 
      if (DataUtil.isNullStr(birthday))
        throw new BizBussinessException("5504", "个人客户出生日期为空!"); 
      int hostBirthday = Integer.parseInt(birthday);
      if ("0".equals(ParamCache.getInstance().getSysParamValue("RISK_AGE_MODE", "0"))) {
        if (age1[1].startsWith("=")) {
          age1[1] = age1[1].substring(1);
          if (DateUtil.getDateOfMonthsLater(hostBirthday, 12 * Integer.parseInt(age1[0])) > Integer.parseInt(DateUtil.getDate()) || 
            DateUtil.getDateOfMonthsLater(hostBirthday, 12 * Integer.parseInt(age1[1])) < Integer.parseInt(DateUtil.getDate()))
            throw new BizBussinessException("2014", "年龄问题答题选项与实际年龄不符！"); 
        } else if (Integer.parseInt(age1[0]) > Integer.parseInt(age1[1])) {
          if (DateUtil.getDateOfMonthsLater(hostBirthday, 12 * Integer.parseInt(age1[0])) >= Integer.parseInt(DateUtil.getDate()) && 
            DateUtil.getDateOfMonthsLater(hostBirthday, 12 * Integer.parseInt(age1[1])) <= Integer.parseInt(DateUtil.getDate()))
            throw new BizBussinessException("2014", "年龄问题答题选项与实际年龄不符！"); 
        } else if (DateUtil.getDateOfMonthsLater(hostBirthday, 12 * Integer.parseInt(age1[0])) > Integer.parseInt(DateUtil.getDate()) || 
          DateUtil.getDateOfMonthsLater(hostBirthday, 12 * Integer.parseInt(age1[1])) <= Integer.parseInt(DateUtil.getDate())) {
          throw new BizBussinessException("2014", "年龄问题答题选项与实际年龄不符！");
        } 
      } else {
        int clientAge = calAge(hostBirthday, Integer.parseInt(DateUtil.getDate()));
        if (age1[1].startsWith("=")) {
          age1[1] = age1[1].substring(1);
          if (Integer.parseInt(age1[0]) > clientAge || Integer.parseInt(age1[1]) < clientAge)
            throw new BizBussinessException("2014", "年龄问题答题选项与实际年龄不符！"); 
        } else if (Integer.parseInt(age1[0]) > Integer.parseInt(age1[1])) {
          if (Integer.parseInt(age1[0]) >= clientAge && Integer.parseInt(age1[1]) <= clientAge)
            throw new BizBussinessException("2014", "年龄问题答题选项与实际年龄不符！"); 
        } else if (Integer.parseInt(age1[0]) > clientAge || Integer.parseInt(age1[1]) <= clientAge) {
          throw new BizBussinessException("2014", "年龄问题答题选项与实际年龄不符！");
        } 
      } 
    } 
  }
  
  private static int calAge(int birthday, int currentDate) {
    LocalDate birthday1 = LocalDate.of(calDate(birthday, 1), calDate(birthday, 2), calDate(birthday, 3));
    LocalDate date = LocalDate.of(calDate(currentDate, 1), calDate(currentDate, 2), calDate(currentDate, 3));
    int age = birthday1.until(date).getYears();
    return age;
  }
  
  private static int calDate(int date, int type) {
    String dateStr = String.valueOf(date);
    switch (type) {
      case 1:
        return Integer.parseInt(dateStr.substring(0, 4));
      case 2:
        return Integer.parseInt(dateStr.substring(4, 6));
      case 3:
        return Integer.parseInt(dateStr.substring(6));
    } 
    return 0;
  }
}
